diff --git a/base/common/src/com/netscape/cms/servlet/profile/model/ProfileDataInfo.java b/base/common/src/com/netscape/cms/servlet/profile/model/ProfilePolicySet.java
similarity index 58%
copy from base/common/src/com/netscape/cms/servlet/profile/model/ProfileDataInfo.java
copy to base/common/src/com/netscape/cms/servlet/profile/model/ProfilePolicySet.java
index 63f005b5447ecb8c080ce7e8ea62a05af178e69e..784f5670d87760fbfc318824d21020d3f2dcc127 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/model/ProfileDataInfo.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/model/ProfilePolicySet.java
@@ -1,5 +1,3 @@
-package com.netscape.cms.servlet.profile.model;
-
 //--- BEGIN COPYRIGHT BLOCK ---
 //This program is free software; you can redistribute it and/or modify
 //it under the terms of the GNU General Public License as published by
@@ -14,59 +12,39 @@ package com.netscape.cms.servlet.profile.model;
 //with this program; if not, write to the Free Software Foundation, Inc.,
 //51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 //
-//(C) 2011 Red Hat, Inc.
+//(C) 2012 Red Hat, Inc.
 //All rights reserved.
 //--- END COPYRIGHT BLOCK ---
-/**
- * 
- */
+package com.netscape.cms.servlet.profile.model;
+
+import java.util.ArrayList;
+import java.util.List;
 
 import javax.xml.bind.annotation.XmlAccessType;
+import javax.xml.bind.annotation.XmlAccessorType;
 import javax.xml.bind.annotation.XmlElement;
 import javax.xml.bind.annotation.XmlRootElement;
-import javax.xml.bind.annotation.XmlAccessorType;
 
-/**
- * @author alee
- * 
- */
-@XmlRootElement(name = "ProfileDataInfo")
+@XmlRootElement
 @XmlAccessorType(XmlAccessType.FIELD)
-public class ProfileDataInfo {
-
-    @XmlElement
-    protected String profileURL;
-
+public class ProfilePolicySet {
     @XmlElement
-    protected String profileId;
-
-    public ProfileDataInfo() {
-        // required for JAXB (defaults)
-    }
+    protected List<ProfilePolicy> policies = new ArrayList<ProfilePolicy>();
 
-    /**
-     * @return the profileURL
-     */
-    public String getProfileURL() {
-        return profileURL;
+    public List<ProfilePolicy> getPolicies() {
+        return policies;
     }
 
-    /**
-     * @param keyURL the profileURL to set
-     */
-    public void setProfileURL(String profileURL) {
-        this.profileURL = profileURL;
+    public void setPolicies(List<ProfilePolicy> policies) {
+        this.policies = policies;
     }
 
-    public void setProfileId(String profileId) {
-        this.profileId = profileId;
+    public void addPolicy(ProfilePolicy policy) {
+        policies.add(policy);
     }
 
-    /**
-     * @return the profile ID in the profileURL
-     */
-    public String getProfileId() {
-        return profileId;
+    public void removePolicy(ProfilePolicy policy) {
+        policies.remove(policy);
     }
 
 }
diff --git a/base/common/src/com/netscape/cms/servlet/request/CertRequestResource.java b/base/common/src/com/netscape/cms/servlet/request/CertRequestResource.java
index 5dc97650dd478471eaa3e3cfb285de2d9ec3364d..7bb23dbd5f687c1f25e3184a6659c87b93d65ad6 100644
--- a/base/common/src/com/netscape/cms/servlet/request/CertRequestResource.java
+++ b/base/common/src/com/netscape/cms/servlet/request/CertRequestResource.java
@@ -27,7 +27,9 @@ import javax.ws.rs.core.MediaType;
 import javax.ws.rs.core.MultivaluedMap;
 
 import com.netscape.certsrv.request.RequestId;
+import com.netscape.cms.servlet.request.model.AgentEnrollmentRequestData;
 import com.netscape.cms.servlet.request.model.CertRequestInfo;
+import com.netscape.cms.servlet.request.model.CertRequestInfos;
 import com.netscape.cms.servlet.request.model.EnrollmentRequestData;
 
 @Path("/certrequest")
@@ -41,29 +43,56 @@ public interface CertRequestResource {
     @Produces({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON, MediaType.TEXT_XML })
     public CertRequestInfo getRequestInfo(@PathParam("id") RequestId id);
 
+    @GET
+    @Path("{id}/agentView")
+    @Produces({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON, MediaType.TEXT_XML })
+    public AgentEnrollmentRequestData reviewRequest(@PathParam("id") RequestId id);
+
     // Enrollment - used to test integration with a browser
     @POST
     @Path("enroll")
     @Produces({ MediaType.TEXT_XML })
     @Consumes({ MediaType.APPLICATION_FORM_URLENCODED })
-    public CertRequestInfo enrollCert(MultivaluedMap<String, String> form);
+    public CertRequestInfos enrollCert(MultivaluedMap<String, String> form);
 
     @POST
     @Path("enroll")
     @Produces({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON, MediaType.TEXT_XML })
     @Consumes({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
-    public CertRequestInfo enrollCert(EnrollmentRequestData data);
+    public CertRequestInfos enrollCert(EnrollmentRequestData data);
 
     @POST
-    @Path("approve/{id}")
-    public void approveRequest(@PathParam("id") RequestId id);
+    @Path("{id}/approve")
+    @Consumes({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
+    public void approveRequest(@PathParam("id") RequestId id, AgentEnrollmentRequestData data);
 
     @POST
-    @Path("reject/{id}")
-    public void rejectRequest(@PathParam("id") RequestId id);
+    @Path("{id}/reject")
+    @Consumes({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
+    public void rejectRequest(@PathParam("id") RequestId id, AgentEnrollmentRequestData data);
 
     @POST
-    @Path("cancel/{id}")
-    public void cancelRequest(@PathParam("id") RequestId id);
+    @Path("{id}/cancel")
+    @Consumes({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
+    public void cancelRequest(@PathParam("id") RequestId id, AgentEnrollmentRequestData data);
 
+    @POST
+    @Path("{id}/update")
+    @Consumes({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
+    public void updateRequest(@PathParam("id") RequestId id, AgentEnrollmentRequestData data);
+
+    @POST
+    @Path("{id}/validate")
+    @Consumes({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
+    public void validateRequest(@PathParam("id") RequestId id, AgentEnrollmentRequestData data);
+
+    @POST
+    @Path("{id}/unassign")
+    @Consumes({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
+    public void unassignRequest(@PathParam("id") RequestId id, AgentEnrollmentRequestData data);
+
+    @POST
+    @Path("{id}/assign")
+    @Consumes({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
+    public void assignRequest(@PathParam("id") RequestId id, AgentEnrollmentRequestData data);
 }
diff --git a/base/common/src/com/netscape/cms/servlet/request/CertRequestResourceService.java b/base/common/src/com/netscape/cms/servlet/request/CertRequestResourceService.java
index 40f57a7a70dad3252d6a46eec012c3441d2ffd03..b31d9961d0b485f4ec525e074405035b4f481659 100644
--- a/base/common/src/com/netscape/cms/servlet/request/CertRequestResourceService.java
+++ b/base/common/src/com/netscape/cms/servlet/request/CertRequestResourceService.java
@@ -18,15 +18,27 @@
 
 package com.netscape.cms.servlet.request;
 
+import javax.ws.rs.PathParam;
 import javax.ws.rs.core.MultivaluedMap;
+import javax.ws.rs.core.Response;
 
+import com.netscape.certsrv.apps.CMS;
+import com.netscape.certsrv.authentication.EAuthException;
+import com.netscape.certsrv.authorization.EAuthzException;
+import com.netscape.certsrv.base.BadRequestDataException;
 import com.netscape.certsrv.base.EBaseException;
+import com.netscape.certsrv.profile.EDeferException;
+import com.netscape.certsrv.profile.EProfileException;
+import com.netscape.certsrv.profile.ERejectException;
+import com.netscape.certsrv.property.EPropertyException;
 import com.netscape.certsrv.request.RequestId;
 import com.netscape.cms.servlet.base.BadRequestException;
 import com.netscape.cms.servlet.base.CMSException;
 import com.netscape.cms.servlet.base.CMSResourceService;
+import com.netscape.cms.servlet.request.model.AgentEnrollmentRequestData;
 import com.netscape.cms.servlet.request.model.CertRequestDAO;
 import com.netscape.cms.servlet.request.model.CertRequestInfo;
+import com.netscape.cms.servlet.request.model.CertRequestInfos;
 import com.netscape.cms.servlet.request.model.EnrollmentRequestData;
 
 /**
@@ -60,51 +72,119 @@ public class CertRequestResourceService extends CMSResourceService implements Ce
     }
 
     // Enrollment - used to test integration with a browser
-    public CertRequestInfo enrollCert(MultivaluedMap<String, String> form) {
+    public CertRequestInfos enrollCert(MultivaluedMap<String, String> form) {
         EnrollmentRequestData data = new EnrollmentRequestData(form);
         return enrollCert(data);
     }
 
-    public CertRequestInfo enrollCert(EnrollmentRequestData data) {
-
+    public CertRequestInfos enrollCert(EnrollmentRequestData data) {
+        CertRequestInfos infos;
         if (data == null) {
             throw new BadRequestException("Bad data input into CertRequestResourceService.enrollCert!");
         }
         CertRequestDAO dao = new CertRequestDAO();
 
         try {
-            dao.submitRequest(data, uriInfo);
+            infos = dao.submitRequest(data, servletRequest, uriInfo, getLocale());
+        } catch (EAuthException e) {
+            CMS.debug("enrollCert: authentication failed: " + e);
+            throw new CMSException(Response.Status.UNAUTHORIZED, e.toString());
+        } catch (EAuthzException e) {
+            CMS.debug("enrollCert: authorization failed: " + e);
+            throw new CMSException(Response.Status.UNAUTHORIZED, e.toString());
+        } catch (BadRequestDataException e) {
+            CMS.debug("enrollCert: bad request data: " + e);
+            throw new CMSException(Response.Status.BAD_REQUEST, e.toString());
         } catch (EBaseException e) {
-            throw new CMSException("Problem enrolling cert in CertRequestResource.enrollCert!");
+            throw new CMSException(e.toString());
         }
 
-        //TODO implement
-        throw new CMSException("CertRequestResourceService.enrollCert not implemented!");
+        return infos;
     }
 
-    public void approveRequest(RequestId id) {
-        if (id == null) {
-            throw new BadRequestException("Bad data input in CertRequestResourceService.approveRequest!");
-        }
-        //TODO implement
-        throw new CMSException("Problem approving request in CertRequestResource.approveRequest!");
+    public void approveRequest(RequestId id, AgentEnrollmentRequestData data) {
+        changeRequestState(id, data, "approve");
     }
 
-    public void rejectRequest(RequestId id) {
-        if (id == null) {
-            throw new BadRequestException("Bad data input into CertRequestResourceService.rejectRequest!");
-        }
-        //TODO implement
+    public void rejectRequest(RequestId id, AgentEnrollmentRequestData data) {
+        changeRequestState(id, data, "reject");
+    }
+
+    public void cancelRequest(RequestId id, AgentEnrollmentRequestData data) {
+        changeRequestState(id, data, "cancel");
+    }
+
+    public void updateRequest(RequestId id, AgentEnrollmentRequestData data) {
+        changeRequestState(id, data, "update");
+    }
 
-        throw new CMSException("Problem rejecting request in CertRequestResource.rejectRequest!");
+    public void validateRequest(RequestId id, AgentEnrollmentRequestData data) {
+        changeRequestState(id, data, "validate");
+    }
+
+    public void unassignRequest(RequestId id, AgentEnrollmentRequestData data) {
+        changeRequestState(id, data, "unassign");
+    }
 
+    public void assignRequest(RequestId id, AgentEnrollmentRequestData data) {
+        changeRequestState(id, data, "assign");
     }
 
-    public void cancelRequest(RequestId id) {
+    public void changeRequestState(RequestId id, AgentEnrollmentRequestData data, String op) {
         if (id == null) {
-            throw new BadRequestException("Bad data input in CertRequestResourceService.cancelRequest!");
+            throw new BadRequestException("Bad data input in CertRequestResourceService. op:" + op);
         }
-        //TODO implement
-        throw new CMSException("Problem cancelling request in CertRequestResource.cancelRequest!");
+
+        CertRequestDAO dao = new CertRequestDAO();
+        try {
+            dao.changeRequestState(id, servletRequest, data, getLocale(), op);
+        } catch (ERejectException e) {
+            CMS.debug("changeRequestState: execution rejected " + e);
+            throw new CMSException(Response.Status.BAD_REQUEST,
+                    CMS.getUserMessage(getLocale(), "CMS_PROFILE_REJECTED", e.toString()));
+        } catch (EDeferException e) {
+            CMS.debug("changeRequestState: execution defered " + e);
+            // TODO do we throw an exception here?
+            throw new CMSException(Response.Status.BAD_REQUEST,
+                    CMS.getUserMessage(getLocale(), "CMS_PROFILE_DEFERRED", e.toString()));
+        } catch (BadRequestDataException e) {
+            CMS.debug("changeRequestState: bad request data: " + e);
+            throw new CMSException(Response.Status.BAD_REQUEST, e.toString());
+        } catch (EPropertyException e) {
+            CMS.debug("changeRequestState: execution error " + e);
+            throw new CMSException(CMS.getUserMessage(getLocale(),
+                    "CMS_PROFILE_PROPERTY_ERROR", e.toString()));
+        } catch (EProfileException e) {
+            CMS.debug("ProfileProcessServlet: execution error " + e);
+            throw new CMSException(CMS.getUserMessage(getLocale(), "CMS_INTERNAL_ERROR"));
+        } catch (EBaseException e) {
+            e.printStackTrace();
+            throw new CMSException("Problem approving request in CertRequestResource.assignRequest!");
+        } catch (RequestNotFoundException e) {
+            throw new CMSException(Response.Status.BAD_REQUEST,
+                    CMS.getUserMessage(getLocale(), "CMS_REQUEST_NOT_FOUND", id.toString()));
+        }
+    }
+
+    public AgentEnrollmentRequestData reviewRequest(@PathParam("id") RequestId id) {
+     // auth and authz
+        AgentEnrollmentRequestData info;
+
+        CertRequestDAO dao = new CertRequestDAO();
+        try {
+            info = dao.reviewRequest(servletRequest, id, uriInfo, getLocale());
+        } catch (EBaseException e) {
+            // log error
+            e.printStackTrace();
+            throw new CMSException("Error getting Cert request info!");
+        }
+
+        if (info == null) {
+            // request does not exist
+            throw new RequestNotFoundException(id);
+        }
+
+        return info;
     }
+
 }
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/AgentEnrollmentRequestData.java b/base/common/src/com/netscape/cms/servlet/request/model/AgentEnrollmentRequestData.java
new file mode 100644
index 0000000000000000000000000000000000000000..fb08743533db21109e31293d0f9bce8ab21b1de3
--- /dev/null
+++ b/base/common/src/com/netscape/cms/servlet/request/model/AgentEnrollmentRequestData.java
@@ -0,0 +1,252 @@
+//--- BEGIN COPYRIGHT BLOCK ---
+//This program is free software; you can redistribute it and/or modify
+//it under the terms of the GNU General Public License as published by
+//the Free Software Foundation; version 2 of the License.
+//
+//This program is distributed in the hope that it will be useful,
+//but WITHOUT ANY WARRANTY; without even the implied warranty of
+//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//GNU General Public License for more details.
+//
+//You should have received a copy of the GNU General Public License along
+//with this program; if not, write to the Free Software Foundation, Inc.,
+//51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+//(C) 2012 Red Hat, Inc.
+//All rights reserved.
+//--- END COPYRIGHT BLOCK ---
+package com.netscape.cms.servlet.request.model;
+
+import java.io.ByteArrayOutputStream;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
+import javax.xml.bind.JAXBContext;
+import javax.xml.bind.Marshaller;
+import javax.xml.bind.annotation.XmlAccessType;
+import javax.xml.bind.annotation.XmlAccessorType;
+import javax.xml.bind.annotation.XmlElement;
+import javax.xml.bind.annotation.XmlRootElement;
+import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
+
+import com.netscape.certsrv.request.RequestId;
+import com.netscape.certsrv.request.RequestIdAdapter;
+import com.netscape.cms.servlet.profile.model.PolicyDefault;
+import com.netscape.cms.servlet.profile.model.ProfileAttribute;
+import com.netscape.cms.servlet.profile.model.ProfilePolicy;
+import com.netscape.cms.servlet.profile.model.ProfilePolicySet;
+
+@XmlRootElement
+@XmlAccessorType(XmlAccessType.FIELD)
+public class AgentEnrollmentRequestData extends EnrollmentRequestData {
+
+    @XmlElement(name="ProfilePolicySet")
+    protected List<ProfilePolicySet> policySets = new ArrayList<ProfilePolicySet>();
+
+    protected String nonce;
+
+    @XmlElement
+    @XmlJavaTypeAdapter(RequestIdAdapter.class)
+    protected RequestId requestId;
+
+    protected String requestType;
+
+    protected String requestStatus;
+
+    protected String requestOwner;
+
+    protected String requestCreationTime;
+
+    protected String requestModificationTime;
+
+    protected String requestNotes;
+
+    protected String profileApprovedBy;
+
+    protected String profileSetId;
+
+    protected String profileIsVisible;
+
+    protected String profileName;
+
+    protected String profileDescription;
+
+    protected String profileRemoteHost;
+
+    protected String profileRemoteAddr;
+
+    public String getNonce() {
+        return nonce;
+    }
+
+    public void setNonce(String nonce) {
+        this.nonce = nonce;
+    }
+
+    public RequestId getRequestId() {
+        return requestId;
+    }
+
+    public void setRequestId(RequestId requestId) {
+        this.requestId = requestId;
+    }
+
+    public String getRequestType() {
+        return requestType;
+    }
+
+    public void setRequestType(String requestType) {
+        this.requestType = requestType;
+    }
+
+    public String getRequestStatus() {
+        return requestStatus;
+    }
+
+    public void setRequestStatus(String requestStatus) {
+        this.requestStatus = requestStatus;
+    }
+
+    public String getRequestOwner() {
+        return requestOwner;
+    }
+
+    public void setRequestOwner(String requestOwner) {
+        this.requestOwner = requestOwner;
+    }
+
+    public String getRequestCreationTime() {
+        return requestCreationTime;
+    }
+
+    public void setRequestCreationTime(String requestCreationTime) {
+        this.requestCreationTime = requestCreationTime;
+    }
+
+    public String getRequestModificationTime() {
+        return requestModificationTime;
+    }
+
+    public void setRequestModificationTime(String requestModificationTime) {
+        this.requestModificationTime = requestModificationTime;
+    }
+
+    public String getRequestNotes() {
+        return requestNotes;
+    }
+
+    public void setRequestNotes(String requestNotes) {
+        this.requestNotes = requestNotes;
+    }
+
+    public String getProfileApprovedBy() {
+        return profileApprovedBy;
+    }
+
+    public void setProfileApprovedBy(String profileApprovedBy) {
+        this.profileApprovedBy = profileApprovedBy;
+    }
+
+    public String getProfileSetId() {
+        return profileSetId;
+    }
+
+    public void setProfileSetId(String profileSetId) {
+        this.profileSetId = profileSetId;
+    }
+
+    public String getProfileIsVisible() {
+        return profileIsVisible;
+    }
+
+    public void setProfileIsVisible(String profileIsVisible) {
+        this.profileIsVisible = profileIsVisible;
+    }
+
+    public String getProfileName() {
+        return profileName;
+    }
+
+    public void setProfileName(String profileName) {
+        this.profileName = profileName;
+    }
+
+    public String getProfileDescription() {
+        return profileDescription;
+    }
+
+    public void setProfileDescription(String profileDescription) {
+        this.profileDescription = profileDescription;
+    }
+
+    public String getProfileRemoteHost() {
+        return profileRemoteHost;
+    }
+
+    public void setProfileRemoteHost(String profileRemoteHost) {
+        this.profileRemoteHost = profileRemoteHost;
+    }
+
+    public String getProfileRemoteAddr() {
+        return profileRemoteAddr;
+    }
+
+    public void setProfileRemoteAddr(String profileRemoteAddr) {
+        this.profileRemoteAddr = profileRemoteAddr;
+    }
+
+    public String toString() {
+        try {
+            JAXBContext context = JAXBContext.newInstance(AgentEnrollmentRequestData.class);
+            Marshaller marshaller = context.createMarshaller();
+            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
+
+            ByteArrayOutputStream stream = new ByteArrayOutputStream();
+
+            marshaller.marshal(this, stream);
+            return stream.toString();
+        } catch (Exception e) {
+            e.printStackTrace();
+        }
+        return null;
+    }
+
+    public List<ProfilePolicySet> getPolicySets() {
+        return policySets;
+    }
+
+    public void setPolicySets(List<ProfilePolicySet> policySets) {
+        this.policySets = policySets;
+    }
+
+    public void addProfilePolicySet(ProfilePolicySet policySet) {
+        policySets.add(policySet);
+    }
+
+    public void removeProfilePolicySet(ProfilePolicySet policySet) {
+        policySets.remove(policySet);
+    }
+
+    @Override
+    public HashMap<String,String> toParams() {
+        HashMap<String,String> ret = super.toParams();
+
+        if (requestId != null) ret.put("requestId", requestId.toString());
+        if (requestNotes != null) ret.put("requestNotes", requestNotes);
+        if (nonce != null) ret.put("nonces", nonce);
+        if (requestType != null) ret.put("requestType", requestType);
+
+        for (ProfilePolicySet policySet: policySets) {
+            for (ProfilePolicy policy: policySet.getPolicies()) {
+                PolicyDefault def = policy.getDef();
+                List<ProfileAttribute> attrs = def.getAttributes();
+                for (ProfileAttribute attr: attrs) {
+                    ret.put(attr.getName(), attr.getValue());
+                }
+            }
+        }
+        return ret;
+    }
+
+}
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/AgentEnrollmentRequestDataFactory.java b/base/common/src/com/netscape/cms/servlet/request/model/AgentEnrollmentRequestDataFactory.java
new file mode 100644
index 0000000000000000000000000000000000000000..fff1a59dfb42fb7aa62c5faa12f7dc1bde06bd8e
--- /dev/null
+++ b/base/common/src/com/netscape/cms/servlet/request/model/AgentEnrollmentRequestDataFactory.java
@@ -0,0 +1,174 @@
+//--- BEGIN COPYRIGHT BLOCK ---
+//This program is free software; you can redistribute it and/or modify
+//it under the terms of the GNU General Public License as published by
+//the Free Software Foundation; version 2 of the License.
+//
+//This program is distributed in the hope that it will be useful,
+//but WITHOUT ANY WARRANTY; without even the implied warranty of
+//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//GNU General Public License for more details.
+//
+//You should have received a copy of the GNU General Public License along
+//with this program; if not, write to the Free Software Foundation, Inc.,
+//51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+//(C) 2012 Red Hat, Inc.
+//All rights reserved.
+//--- END COPYRIGHT BLOCK ---
+package com.netscape.cms.servlet.request.model;
+
+import java.util.Enumeration;
+import java.util.Locale;
+
+import javax.servlet.http.HttpServletRequest;
+import javax.ws.rs.core.UriInfo;
+
+import com.netscape.certsrv.apps.CMS;
+import com.netscape.certsrv.base.EBaseException;
+import com.netscape.certsrv.base.IArgBlock;
+import com.netscape.certsrv.base.Nonces;
+import com.netscape.certsrv.profile.EProfileException;
+import com.netscape.certsrv.profile.IPolicyDefault;
+import com.netscape.certsrv.profile.IProfile;
+import com.netscape.certsrv.profile.IProfileInput;
+import com.netscape.certsrv.profile.IProfilePolicy;
+import com.netscape.certsrv.property.EPropertyException;
+import com.netscape.certsrv.request.IRequest;
+import com.netscape.cms.servlet.common.CMSRequest;
+import com.netscape.cms.servlet.processors.Processor;
+import com.netscape.cms.servlet.profile.model.PolicyConstraint;
+import com.netscape.cms.servlet.profile.model.PolicyConstraintFactory;
+import com.netscape.cms.servlet.profile.model.PolicyDefault;
+import com.netscape.cms.servlet.profile.model.PolicyDefaultFactory;
+import com.netscape.cms.servlet.profile.model.ProfileInput;
+import com.netscape.cms.servlet.profile.model.ProfileInputFactory;
+import com.netscape.cms.servlet.profile.model.ProfilePolicy;
+import com.netscape.cms.servlet.profile.model.ProfilePolicySet;
+
+public class AgentEnrollmentRequestDataFactory {
+
+    public static AgentEnrollmentRequestData create(IRequest request, IProfile profile, UriInfo uriInfo, Locale locale) throws EBaseException {
+        AgentEnrollmentRequestData ret = new AgentEnrollmentRequestData();
+
+        if (request.getRequestType().equals("renewal")) {
+            ret.setIsRenewal(true);
+        } else {
+            ret.setIsRenewal(false);
+        }
+
+        ret.setRequestId(request.getRequestId());
+        ret.setRequestType(request.getRequestType());
+        ret.setRequestStatus(request.getRequestStatus().toString());
+        if (request.getRequestOwner() == null) {
+            ret.setRequestOwner("");
+        } else {
+            ret.setRequestOwner(request.getRequestOwner());
+        }
+        ret.setRequestCreationTime(request.getCreationTime().toString());
+        ret.setRequestModificationTime(request.getModificationTime().toString());
+
+        ret.setProfileId(profile.getId());
+        ret.setProfileApprovedBy(request.getExtDataInString("profileApprovedBy"));
+        ret.setProfileSetId(request.getExtDataInString("profileSetId"));
+        if (profile.isVisible()) {
+            ret.setProfileIsVisible("true");
+        } else {
+            ret.setProfileIsVisible("false");
+        }
+
+        ret.setProfileName(profile.getName(locale));
+        ret.setProfileDescription(profile.getDescription(locale));
+        ret.setProfileRemoteHost(request.getExtDataInString("profileRemoteHost"));
+        ret.setProfileRemoteAddr(request.getExtDataInString("profileRemoteAddr"));
+        if (request.getExtDataInString("requestNotes") == null) {
+            ret.setRequestNotes("");
+        } else {
+            ret.setRequestNotes(request.getExtDataInString("requestNotes"));
+        }
+
+        // populate profile inputs
+        Enumeration<String> inputIds = profile.getProfileInputIds();
+        while (inputIds.hasMoreElements()) {
+            IProfileInput input = profile.getProfileInput(inputIds.nextElement());
+            ProfileInput addInput = ProfileInputFactory.create(input, request, locale);
+            ret.addInput(addInput);
+        }
+
+        String profileSetId = request.getExtDataInString("profileSetId");
+        CMS.debug("createAgentCertRequestInfo: profileSetId=" + profileSetId);
+        Enumeration<String> policyIds = (profileSetId != null && profileSetId.length() > 0) ?
+                profile.getProfilePolicyIds(profileSetId) : null;
+        ProfilePolicySet dataPolicySet = new ProfilePolicySet();
+
+        if (policyIds != null) {
+            while (policyIds.hasMoreElements()) {
+                String id = policyIds.nextElement();
+                CMS.debug("policyId:" + id);
+                IProfilePolicy policy = profile.getProfilePolicy(profileSetId, id);
+                ProfilePolicy dataPolicy = new ProfilePolicy();
+
+                //populate defaults
+                IPolicyDefault def = policy.getDefault();
+                PolicyDefault dataDef = PolicyDefaultFactory.create(request, locale, def);
+                dataPolicy.setDef(dataDef);
+
+                //populate constraints
+                PolicyConstraint dataCons = PolicyConstraintFactory.create(locale, policy.getConstraint());
+                dataPolicy.setConstraint(dataCons);
+
+                dataPolicySet.addPolicy(dataPolicy);
+            }
+        }
+
+
+        ret.addProfilePolicySet(dataPolicySet);
+
+        // TODO populate profile outputs
+        return ret;
+    }
+
+    public static AgentEnrollmentRequestData create(CMSRequest cmsReq, IProfile profile, Nonces nonces, Locale locale)
+            throws EPropertyException, EProfileException {
+        HttpServletRequest req = cmsReq.getHttpReq();
+        IRequest ireq = cmsReq.getIRequest();
+        IArgBlock params = cmsReq.getHttpParams();
+
+        AgentEnrollmentRequestData ret = new AgentEnrollmentRequestData();
+        ret.setProfileId(profile.getId());
+        ret.setRequestNotes(req.getParameter("requestNotes"));
+        ret.setRequestId(ireq.getRequestId());
+
+        if (nonces != null) {
+            ret.setNonce(req.getParameter(Processor.ARG_REQUEST_NONCE));
+        }
+
+        // populate profile policy values
+        String profileSetId = ireq.getExtDataInString("profileSetId");
+        Enumeration<String> policyIds = (profileSetId != null && profileSetId.length() > 0) ?
+                profile.getProfilePolicyIds(profileSetId) : null;
+        ProfilePolicySet dataPolicySet = new ProfilePolicySet();
+
+        if (policyIds != null) {
+            while (policyIds.hasMoreElements()) {
+                String id = policyIds.nextElement();
+                CMS.debug("policyId:" + id);
+                IProfilePolicy policy = profile.getProfilePolicy(profileSetId, id);
+                com.netscape.cms.servlet.profile.model.ProfilePolicy dataPolicy =
+                        new com.netscape.cms.servlet.profile.model.ProfilePolicy();
+
+                //populate defaults
+                IPolicyDefault def = policy.getDefault();
+                PolicyDefault dataDef = PolicyDefaultFactory.create(params, locale, def);
+                dataPolicy.setDef(dataDef);
+
+                dataPolicySet.addPolicy(dataPolicy);
+                CMS.debug(dataPolicy.toString());
+            }
+        }
+
+        ret.addProfilePolicySet(dataPolicySet);
+
+        return ret;
+    }
+
+}
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/CMSRequestInfo.java b/base/common/src/com/netscape/cms/servlet/request/model/CMSRequestInfo.java
index b86b39fbdc3970db4e16fae9aedabb22a61c0a8f..07a02cd1c640e9c54e6308a192a76473c7041011 100644
--- a/base/common/src/com/netscape/cms/servlet/request/model/CMSRequestInfo.java
+++ b/base/common/src/com/netscape/cms/servlet/request/model/CMSRequestInfo.java
@@ -1,3 +1,20 @@
+//--- BEGIN COPYRIGHT BLOCK ---
+//This program is free software; you can redistribute it and/or modify
+//it under the terms of the GNU General Public License as published by
+//the Free Software Foundation; version 2 of the License.
+//
+//This program is distributed in the hope that it will be useful,
+//but WITHOUT ANY WARRANTY; without even the implied warranty of
+//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//GNU General Public License for more details.
+//
+//You should have received a copy of the GNU General Public License along
+//with this program; if not, write to the Free Software Foundation, Inc.,
+//51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+//(C) 2012 Red Hat, Inc.
+//All rights reserved.
+//--- END COPYRIGHT BLOCK ---
 package com.netscape.cms.servlet.request.model;
 
 import javax.xml.bind.annotation.XmlAccessType;
